'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerAssertions = undefined;

var _should = require('should');

var _should2 = _interopRequireDefault(_should);

var _assertions = require('./assertions');

var _assertions2 = _interopRequireDefault(_assertions);

var _actionWithInitialState = require('./actionWithInitialState');

var _actionWithInitialState2 = _interopRequireDefault(_actionWithInitialState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function withState(state) {
  this.obj = new _actionWithInitialState2.default(this.obj, state);
}

function dispatchActionsFunction(assert, assertWithState, expectedActions, done) {
  if (this.obj instanceof _actionWithInitialState2.default) {
    var action = this.obj.action;
    var state = this.obj.state;
    assertWithState(state, action, expectedActions, done);
  } else {
    assert(this.obj, expectedActions, done);
  }
}

function dispatchActions(expectedActions, done) {
  dispatchActionsFunction.call(this, _assertions2.default.toDispatchActions, _assertions2.default.toDispatchActionsWithState, expectedActions, done);
}

function notDispatchActions(expectedActions, done) {
  dispatchActionsFunction.call(this, _assertions2.default.toNotDispatchActions, _assertions2.default.toNotDispatchActionsWithState, expectedActions, done);
}

function registerAssertions() {
  _should2.default.Assertion.add('withState', withState);
  _should2.default.Assertion.alias('withState', 'state');
  _should2.default.Assertion.add('dispatchActions', dispatchActions);
  _should2.default.Assertion.add('notDispatchActions', notDispatchActions);
}

exports.registerAssertions = registerAssertions;